# $Id: add_submit.py 286 2005-12-12 16:51:00Z schluep $
# Copyright (c) 2002 - 2005, Infrae and Samuel Schluep, ETH Zurich.
# All rights reserved.
# See also LICENSE_INFRAE.txt and LICENSE.txt
#
# Copied from the Silva core and adapted in order to automatically
# generate a valid id based on the tilte if the id field is blank.

from Products.SilvaGlossary import helpers

model = context.REQUEST.model
view = context
REQUEST = context.REQUEST

# if we cancelled, then go back to edit tab
if REQUEST.has_key('add_cancel'):
    return model.edit['tab_edit']()

# validate form
from Products.Formulator.Errors import ValidationError, FormValidationError
try:
    result = view.form.validate_all(REQUEST)
except FormValidationError, e:
    # in case of errors go back to add page and re-render form
    return view.add_form(message_type="error",
        message=view.render_form_errors(e))

# get id and set up the mangler
#id = mangle.Id(model, result['object_id'])
id = result['object_id']
if id == '':
    id = result['object_title'].lower()
    id = helpers.Id(model, id)
    id.cook_valid()
else:
    id = helpers.Id(model, id)

# remove them from result dictionary
del result['object_id']

# try to cope with absence of title in form (happens for ghost)
if result.has_key('object_title'):
    title = result['object_title']
    del result['object_title']
else:
    title = ""

# if we don't have the right id, reject adding
id_check = id.validate()
if id_check == id.OK:
    id = str(id)
else:
    REQUEST.form['field_object_id'] = str(id).lower()
    return view.add_form(message_type="error",
        message=view.get_id_status_text(id))

# process data in result and add using validation result
object = context.add_submit_helper(model, id, title, result)

# update last author info in new object
object.sec_update_last_author_info()

# now go to tab_edit in case of add and edit, back to container if not.
if REQUEST.has_key('add_edit_submit'):
    REQUEST.RESPONSE.redirect(object.absolute_url() + '/edit/tab_edit')
else:
    return model.edit['tab_edit'](message_type="feedback", 
                         message="Added %s %s." % (object.meta_type, view.quotify(id)))
